OpenTTD: ICUParagraphLayout Class Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Data Structures | Public Types | Public Member Functions | Static Public Attributes | Private Attributes
ICUParagraphLayout Class Reference

Wrapper for doing layouts with ICU. More...

Inheritance diagram for ICUParagraphLayout:

## Data Structures
class | ICULine
| A single line worth of VisualRuns. More...
class | ICUVisualRun
| Visual run contains data about the bit of text with the same font. More...

## Public Types
typedef UChar | CharType
| Helper for GetLayouter, to get the right type.

## Public Member Functions
| ICUParagraphLayout (ParagraphLayout *p)
void | Reflow ()
ParagraphLayouter::Line * | NextLine (int max_width)
Public Member Functions inherited from AutoDeleteSmallVector< ParagraphLayouter::Line *, 4 >
void | Clear ()
| Remove all items from the list.
Public Member Functions inherited from SmallVector< ParagraphLayouter::Line *, S >
| SmallVector (const SmallVector &other)
| Copy constructor.
| SmallVector (const SmallVector< ParagraphLayouter::Line *, X > &other)
| Generic copy constructor.
SmallVector & | operator= (const SmallVector &other)
| Assignment.
SmallVector & | operator= (const SmallVector< ParagraphLayouter::Line *, X > &other)
| Generic assignment.
void | Assign (const SmallVector< ParagraphLayouter::Line *, X > &other)
| Assign items from other vector.
void | Reset ()
| Remove all items from the list and free allocated memory.
void | Compact ()
| Compact the list down to the smallest block size boundary.
ParagraphLayouter::Line ** | Append (uint to_add=1)
| Append an item and return it.
void | Resize (uint num_items)
| Set the size of the vector, effectively truncating items from the end or appending uninitialised ones.
const ParagraphLayouter::Line ** | Find (const ParagraphLayouter::Line *&item) const
| Search for the first occurrence of an item.
ParagraphLayouter::Line ** | Find (const ParagraphLayouter::Line *&item)
| Search for the first occurrence of an item.
int | FindIndex (const ParagraphLayouter::Line *&item) const
| Search for the first occurrence of an item.
bool | Contains (const ParagraphLayouter::Line *&item) const
| Tests whether a item is present in the vector.
void | Erase (ParagraphLayouter::Line **item)
| Removes given item from this vector.
void | ErasePreservingOrder (uint pos, uint count=1)
| Remove items from the vector while preserving the order of other items.
bool | Include (const ParagraphLayouter::Line *&item)
| Tests whether a item is present in the vector, and appends it to the end if not.
uint | Length () const
| Get the number of items in the list.
const ParagraphLayouter::Line ** | Begin () const
| Get the pointer to the first item (const)
ParagraphLayouter::Line ** | Begin ()
| Get the pointer to the first item.
const ParagraphLayouter::Line ** | End () const
| Get the pointer behind the last valid item (const)
ParagraphLayouter::Line ** | End ()
| Get the pointer behind the last valid item.
const ParagraphLayouter::Line ** | Get (uint index) const
| Get the pointer to item "number" (const)
ParagraphLayouter::Line ** | Get (uint index)
| Get the pointer to item "number".
const ParagraphLayouter::Line *& | operator[] (uint index) const
| Get item "number" (const)
ParagraphLayouter::Line *& | operator[] (uint index)
| Get item "number".

## Static Public Attributes
static const bool | SUPPORTS_RTL = true
| Helper for GetLayouter, to get whether the layouter supports RTL.

## Private Attributes
ParagraphLayout * | p
| The actual ICU paragraph layout.

## Additional Inherited Members
Protected Attributes inherited from SmallVector< ParagraphLayouter::Line *, S >
ParagraphLayouter::Line ** | data
| The pointer to the first item.
uint | items
| The number of items stored.
uint | capacity
| The available space for storing items.

## Detailed Description

Wrapper for doing layouts with ICU.

Definition at line 128 of file gfx_layout.cpp.

## Member Typedef Documentation

typedef UChar ICUParagraphLayout::CharType

Helper for GetLayouter, to get the right type.

Definition at line 132 of file gfx_layout.cpp.

## Field Documentation

const bool ICUParagraphLayout::SUPPORTS_RTL = true
| static

Helper for GetLayouter, to get whether the layouter supports RTL.

Definition at line 134 of file gfx_layout.cpp.

The documentation for this class was generated from the following file:

- src/gfx_layout.cpp